'''
utaufile.dictionary包括歌词转换字典，供utaufile.replacelyric()使用
ro2hi:罗马音转平假名
hi2ro:平假名转罗马音
'''
#罗马音转平假名
ro2hi={
    "a":"あ",
    "i":"い",
    "u":"う",
    "e":"え",
    "o":"お",
    "ka":"か",
    "ki":"き",
    "ku":"く",
    "ke":"け",
    "ko":"こ",
    "kwa":"くゎ",
    "kya":"きゃ",
    "kyu":"きゅ",
    "kyo":"きょ",
    "sa":"さ",
    "shi":"し",
    "su":"す",
    "se":"せ",
    "so":"そ",
    "sha":"しゃ",
    "shu":"しゅ",
    "sho":"しょ",
    "ta":"た",
    "chi":"ち",
    "tsu":"つ",
    "te":"て",
    "to":"と",
    "cha":"ちゃ",
    "chu":"ちゅ",
    "cho":"ちょ",
    "na":"な",
    "ni":"に",
    "nu":"ぬ",
    "ne":"ね",
    "no":"の",
    "nya":"にゃ",
    "nyu":"にゅ",
    "nyo":"にょ",
    "ha":"は",
    "hi":"ひ",
    "fu":"ふ",
    "he":"へ",
    "ho":"ほ",
    "hya":"ひゃ",
    "hyu":"ひゅ",
    "hyo":"ひょ",
    "ma":"ま",
    "mi":"み",
    "mu":"む",
    "me":"め",
    "mo":"も",
    "mya":"みゃ",
    "myu":"みゅ",
    "myo":"みょ",
    "ya":"や",
    "yu":"ゆ",
    "yo":"よ",
    "ra":"ら",
    "ri":"り",
    "ru":"る",
    "re":"れ",
    "ro":"ろ",
    "rya":"りゃ",
    "ryu":"りゅ",
    "ryo":"りょ",
    "la":"ら",
    "li":"り",
    "lu":"る",
    "le":"れ",
    "lo":"ろ",
    "lya":"りゃ",
    "lyu":"りゅ",
    "lyo":"りょ",
    "wa":"わ",
    "wo":"を",
    "n":"ん",
    "ga":"が",
    "gi":"ぎ",
    "gu":"ぐ",
    "ge":"げ",
    "go":"ご",
    "gwa":"ぐゎ",
    "gyu":"ぎゅ",
    "gyo":"ぎょ",
    "za":"ざ",
    "ji":"じ",
    "zu":"ず",
    "ze":"ぜ",
    "zo":"ぞ",
    "ja":"じゃ",
    "ju":"じゅ",
    "jo":"じょ",
    "da":"だ",
    "di":"ぢ",
    "dzu":"づ",
    "de":"で",
    "do":"ど",
    "ba":"ば",
    "bi":"び",
    "bu":"ぶ",
    "be":"べ",
    "bo":"ぼ",
    "bya":"びゃ",
    "byu":"びゅ",
    "byo":"びょ",
    "pa":"ぱ",
    "pi":"ぴ",
    "pu":"ぷ",
    "pe":"ぺ",
    "po":"ぽ",
    "pya":"ぴゃ",
    "pyu":"ぴゅ",
    "pyo":"ぴょ",
    "ye":"いぇ",
    "kye":"きぇ",
    "she":"しぇ",
    "che":"ちぇ",
    "nye":"にぇ",
    "mye":"みぇ",
    "gye":"ぎぇ",
    "je":"じぇ",
    "bye":"びぇ",
    "pye":"ぴぇ",
    "wi":"うぃ",
    "wu":"う",
    "we":"うぇ",
    "kwi":"くぃ",
    "kwe":"くぇ",
    "kwo":"くぉ",
    "swa":"すぁ",
    "swe":"すぇ",
    "swo":"すぉ",
    "tsa":"つぁ",
    "tsi":"つぃ",
    "tse":"つぇ",
    "tso":"つぉ",
    "nwa":"ぬぁ",
    "nwi":"ぬぃ",
    "nwe":"ぬぇ",
    "nwo":"ぬぉ",
    "fa":"ふぁ",
    "fi":"ふぃ",
    "fe":"ふぇ",
    "fo":"ふぉ",
    "mwa":"むぁ",
    "mwi":"むぃ",
    "mwe":"むぇ",
    "mwo":"むぉ",
    "rwa":"るぁ",
    "rwi":"るぃ",
    "rwe":"るぇ",
    "rwo":"るぉ",
    "gwi":"ぐぃ",
    "gwe":"ぐぇ",
    "gwo":"ぐぉ",
    "zwa":"ずぁ",
    "zi":"ずぃ",
    "zwe":"ずぇ",
    "zwo":"ずぉ",
    "bwa":"ぶぁ",
    "bwi":"ぶぃ",
    "bwe":"ぶぇ",
    "bwo":"ぶぉ",
    "pwa":"ぷぁ",
    "pwi":"ぷぃ",
    "pwe":"ぷぇ",
    "pwo":"ぷぉ",
    "ti":"てぃ",
    "tu":"てゅ",
    "du":"でゅ",
    "tou":"とぅ",
    "dou":"どぅ",
    "va":"ヴぁ",
    "vi":"ヴぃ",
    "vu":"ヴ",
    "ve":"ヴぇ",
    "vo":"ヴぉ"}

#平假名转罗马音
hi2ro={
    "あ":"a",
    "い":"i",
    "う":"u",
    "え":"e",
    "お":"o",
    "か":"ka",
    "き":"ki",
    "く":"ku",
    "け":"ke",
    "こ":"ko",
    "さ":"sa",
    "すぃ":"si",
    "す":"su",
    "せ":"se",
    "そ":"so",
    "た":"ta",
    "てぃ":"ti",
    "とぅ":"tu",
    "て":"te",
    "と":"to",
    "な":"na",
    "に":"ni",
    "ぬ":"nu",
    "ね":"ne",
    "の":"no",
    "は":"ha",
    "ひ":"hi",
    "ふ":"fu",
    "へ":"he",
    "ほ":"ho",
    "ま":"ma",
    "み":"mi",
    "む":"mu",
    "め":"me",
    "も":"mo",
    "や":"ya",
    "ゆ":"yu",
    "いぇ":"ye",
    "よ":"yo",
    "ら":"ra",
    "り":"ri",
    "る":"ru",
    "れ":"re",
    "ろ":"ro",
    "わ":"wa",
    "うぃ":"wi",
    "うぇ":"we",
    "うぉ":"wo",
    "を":"o",
    "が":"ga",
    "ぎ":"gi",
    "ぐ":"gu",
    "げ":"ge",
    "ご":"go",
    "ざ":"za",
    "ずぃ":"zi",
    "ず":"zu",
    "ぜ":"ze",
    "ぞ":"zo",
    "だ":"da",
    "でぃ":"di",
    "どぅ":"du",
    "で":"de",
    "ど":"do",
    "ば":"ba",
    "び":"bi",
    "ぶ":"bu",
    "べ":"be",
    "ぼ":"bo",
    "ぱ":"pa",
    "ぴ":"pi",
    "ぷ":"pu",
    "ぺ":"pe",
    "ぽ":"po",
    "きゃ":"kya",
    "きゅ":"kyu",
    "きぇ":"kye",
    "きょ":"kyo",
    "しゃ":"sha",
    "し":"shi",
    "しゅ":"shu",
    "しぇ":"she",
    "しょ":"sho",
    "ちゃ":"cha",
    "ち":"chi",
    "ちゅ":"chu",
    "ちぇ":"che",
    "ちょ":"cho",
    "つぁ":"tsa",
    "つぃ":"tsi",
    "つ":"tsu",
    "つぇ":"tse",
    "つぉ":"tso",
    "にゃ":"nya",
    "にゅ":"nyu",
    "にぇ":"nye",
    "にょ":"nyo",
    "ひゃ":"hya",
    "ひゅ":"hyu",
    "ひぇ":"hye",
    "ひょ":"hyo",
    "ふぁ":"fa",
    "ふぃ":"fi",
    "ふぇ":"fe",
    "ふぉ":"fo",
    "みゃ":"mya",
    "みゅ":"myu",
    "みぇ":"mye",
    "みょ":"myo",
    "りゃ":"rya",
    "りゅ":"ryu",
    "りぇ":"rye",
    "りょ":"ryo",
    "ぎゃ":"gya",
    "ぎゅ":"gyu",
    "ぎぇ":"gye",
    "ぎょ":"gyo",
    "じゃ":"ja",
    "じ":"ji",
    "じゅ":"ju",
    "じぇ":"je",
    "じょ":"jo",
    "びゃ":"bya",
    "びゅ":"byu",
    "びぇ":"bye",
    "びょ":"byo",
    "ぴゃ":"pya",
    "ぴゅ":"pyu",
    "ぴぇ":"pye",
    "ぴょ":"pyo",
    "ん":"n",
    "くぁ":"qa",
    "くぃ":"qi",
    "くぇ":"qe",
    "くぉ":"qo",
    "てゅ":"tyu",
    "ふゅ":"fyu",
    "づぁ":"dza",
    "づぃ":"dzi",
    "づ":"dzu",
    "づぇ":"dze",
    "づぉ":"dzo",
    "でゅ":"dyu",
    "ヴゅ":"vyu",
    "ヴぁ":"va",
    "ヴぃ":"vi",
    "ヴ":"vu",
    "ヴぇ":"ve",
    "ヴぉ":"vo",
    "ぢゃ":"dja",
    "ぢ":"dji",
    "ぢゅ":"dju",
    "ぢぇ":"dje",
    "ぢょ":"djo",
    "ガ":"nga",
    "ギ":"ngi",
    "グ":"ngu",
    "ゲ":"nge",
    "ゴ":"ngo"}